package org.GNOME.Speech;
import org.GNOME.Bonobo.*;
import org.GNOME.Speech.*;
import org.GNOME.Accessibility.*;
import org.omg.CORBA.*;
import java.util.Vector;
import java.io.*;
import org.GNOME.Bonobo.*;
import com.sun.speech.freetts.Voice;
import com.sun.speech.freetts.en.us.CMULexicon;
import com.sun.speech.freetts.audio.JavaStreamingAudioPlayer;
import com.sun.speech.freetts.audio.JavaClipAudioPlayer;

public class FreeTTSSynthesisDriver extends UnknownImpl implements SynthesisDriverOperations {

    private Voice v;
    private SpeechThread thread;
    
    public void bonoboActivate (String iid) {
	ORB orb = AccessUtil.getORB ();
	String ior = orb.object_to_string (tie._this_object());
	_bonoboActivate (ior, iid);
    }

    public native void _bonoboActivate (String ior, String iid);

    static {
	System.loadLibrary ("freettsdriver");
	}
    
    public FreeTTSSynthesisDriver () {
	poa = JavaBridge.getRootPOA ();
	tie = new SynthesisDriverPOATie (this, poa);
	try {
	    poa.activate_object(tie);
	    bonoboActivate ("OAFIID:GNOME_Speech_SynthesisDriver_FreeTTS:proto0.1");
	} catch (Exception e) {
		System.err.println ("error: " + e);
	}
    }

    /* Descriptive attributes */

     public String driverName () {
	return "FreeTTS Gnome Speech Driver";
    }

    public String synthesizerName () {
	return "FreeTTS";
    }

    public String driverVersion () {
	return "0.2";
    }
    
    public String synthesizerVersion () {
	return "1.1.1";
    }

    public boolean driverInit () {
	System.setProperty
	    ("com.sun.speech.freetts.audio.AudioPlayer.cancelDelay", "0");
	String databaseName = System.getProperty
	    ("diphoneDatabase", "cmu_kal/diphone_units16.bin");
	v = (Voice) new com.sun.speech.freetts.en.us.CMUDiphoneVoice ();
	v.getFeatures().setString
	    (Voice.DATABASE_NAME, databaseName);	
	v.setLexicon (new CMULexicon ());
	v.load ();
	v.setAudioPlayer (new JavaStreamingAudioPlayer());
	thread = new SpeechThread(v);
	thread.start ();
	return true;
    }
    
    public boolean isInitialized () {
	return true;
    }

    public org.GNOME.Speech.Parameter[] getSupportedParameters () {
	return null;
    }
    
    public String getParameterValueDescription (String name, double value) {
	return null;
    }
    
    public double getParameterValue (String name) {
	return 0.0;
    }

    public void setParameterValue (String name, double value) {
    }

    public boolean say (String text) {
	thread.addString(text);
	return true;
    }

    public boolean stop () {
	thread.removeAll ();
	return true;
    }
    
    public boolean isSpeaking () {
	return false;
    }

    public void _wait () {
    }

    public String[] getVoices () {
	return null;
    }

    public String[] getDefaultVoices () {
	return null;
    }
    
    public void saveVoice (String name) {
    }

    public static void main (String [] args) {
	try {
	    FreeTTSSynthesisDriver driver = new FreeTTSSynthesisDriver ();	    
	    AccessUtil.getORB().run();
	} catch (Exception e) {
		System.err.println ("error: " + e);
	    }
    }


    class SpeechThread extends Thread {
	private Voice v;
	private boolean done = false;
	private Vector strings = new Vector ();
	
	public SpeechThread (Voice v) {
	    this.v = v;
	}
	
	public void run () {
	    while (done == false) {
		synchronized (strings) {
		    if (strings.size() == 0) {
			try {
			    strings.wait ();
			} catch (InterruptedException ie) {
			}
		    }
		}
		String text = (String) strings.remove(0);
		v.speak (text);
	    }
	}
	
	public void addString (String text) {
	    synchronized (strings) {
		strings.add(text);
		strings.notifyAll();
	    }
	}


	public synchronized void removeAll () {
	    v.getAudioPlayer().cancel();
	    strings.removeAllElements ();
	}
    }
}
